/*-------------------------------------------------------------------------+
|                                                                          |
| Copyright 2005-2011 The ConQAT Project                                   |
|                                                                          |
| Licensed under the Apache License, Version 2.0 (the "License");          |
| you may not use this file except in compliance with the License.         |
| You may obtain a copy of the License at                                  |
|                                                                          |
|    http://www.apache.org/licenses/LICENSE-2.0                            |
|                                                                          |
| Unless required by applicable law or agreed to in writing, software      |
| distributed under the License is distributed on an "AS IS" BASIS,        |
| WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| See the License for the specific language governing permissions and      |
| limitations under the License.                                           |
+-------------------------------------------------------------------------*/
package org.conqat.ide.commons.ui.treemap;

import org.eclipse.swt.events.MouseEvent;

/**
 * Interface for listening to TreeMap events
 * 
 * @author Timo Besenreuther
 * @author $Author: deissenb $
 * @version $Rev: 34252 $
 * @levd.rating GREEN Hash: 7DA82393C3DAFC02FB632DECDD2773F6
 */

public interface ITreeMapListener<T> {

	/**
	 * Triggered, when mouse enters an element. This not called anymore, when
	 * the mouse moves within the element.
	 */
	void mouseEnterElement(T element);

	/** Triggered, when mouse exits the map */
	void mouseExitElement();

	/** Triggered, when an element is clicked */
	void clickedElement(T element, MouseEvent e);

	/** Triggered, when an element is double clicked */
	void doubleClickedElement(T element, MouseEvent e);
}